VirtualBox

source: vbox/trunk/configure@ 30998

Last change on this file since 30998 was 30998, checked in by vboxsync, 14 years ago

configure: allow to disable Java bindings

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 65.6 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2009 Oracle Corporation
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License (GPL) as published by the Free Software
12# Foundation, in version 2 as it comes in the "COPYING" file of the
13# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
14# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
47case "$OS" in
48 linux)
49 ;;
50 darwin)
51 ;;
52 freebsd)
53 ;;
54 sunos)
55 OS='solaris'
56 ;;
57 *)
58 echo "Cannot determine OS!"
59 exit 1
60 ;;
61esac
62
63#
64# Defaults
65#
66OSE=1
67ODIR="`pwd`/"
68ODIR_OVERRIDE=0
69OUT_PATH=""
70OUT_PATH_OVERRIDE=0
71SETUP_WINE=
72TARGET_MACHINE=""
73TARGET_CPU=""
74WITH_XPCOM=1
75WITH_PYTHON=1
76WITH_JAVA=1
77WITH_VMMRAW=1
78WITH_LIBIDL=1
79WITH_GSOAP=0
80WITH_QT4=1
81WITH_SDL=1
82WITH_SDL_TTF=1
83WITH_X11=1
84WITH_ALSA=1
85WITH_PULSE=1
86WITH_DBUS=1
87WITH_KMODS=1
88WITH_OPENGL=1
89WITH_HARDENING=1
90WITH_VDE=0
91BUILD_LIBXML2=
92BUILD_LIBXSLT=
93BUILD_LIBCURL=
94BUILD_LIBSSL=
95PASSIVE_MESA=0
96CC="gcc"
97CC32=""
98CC64=""
99CXX="g++"
100CXX32=""
101CXX64=""
102BCC="bcc"
103YASM="yasm"
104IASL="iasl"
105AS86="as86"
106XSLTPROC="xsltproc"
107GENISOIMAGE="genisoimage"
108MKISOFS="mkisofs"
109INCCRYPTO=""
110LIBCRYPTO="-lcrypto"
111LIBPTHREAD="-lpthread"
112LIBCAP="-lcap"
113GSOAP=""
114GSOAP_IMPORT=""
115INCX11="/usr/local/include"
116LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
117LIBXCURSOR="-lXcursor"
118LIBXMU="-lXmu"
119LIBXINERAMA="-lXinerama"
120LIBXRANDR="-lXrandr"
121MESA="-lGL"
122INCZ=""
123LIBZ="-lz"
124INCPNG=""
125LIBPNG="-lpng"
126CXX_FLAGS=""
127if [ "$OS" = "freebsd" ]; then
128 INCCURL="-I/usr/local/include"
129 LIBCURL="-L/usr/local/lib -lcurl"
130 INCPULSE="-I/usr/local/include"
131 LIBPULSE="-L/usr/local/lib"
132else
133 INCCURL=""
134 LIBCURL="-lcurl"
135fi
136PKGCONFIG="`which_wrapper pkg-config`"
137PYTHONDIR="/usr /usr/local"
138QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr /usr/local"
139QT4DIR_PKGCONFIG=1
140QT4UIC3DIR="/usr/bin"
141KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
142DEVDIR="`cd \`dirname $0\`; pwd`/tools"
143if [ -d "/lib/modules/`uname -r`/build" ]; then
144 LINUX="/lib/modules/`uname -r`/build"
145else
146 LINUX="/usr/src/linux"
147fi
148KCHMVIEWER="kchmviewer"
149LOG="configure.log"
150CNF="AutoConfig.kmk"
151ENV="env.sh"
152BUILD_TYPE="release"
153# the restricting tool is ar (mri mode).
154INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
155
156if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
157 echo "Error: VBox base path contains invalid characters!"
158 exit 1
159fi
160
161# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
162if [ "$OS" = "darwin" ]; then
163 ECHO_N="/bin/echo -n"
164else
165 ECHO_N="echo -n"
166fi
167
168
169cleanup()
170{
171 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
172}
173
174fail()
175{
176 if [ -z "$nofatal" -o "x$1" != "x" ]; then
177 cleanup
178 rm -f $ENV
179 exit 1
180 fi
181}
182
183log()
184{
185 echo "$1"
186 echo "$1" >> $LOG
187}
188
189log_success()
190{
191 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
192 echo "OK."
193 echo "$1" >> $LOG
194 echo >> $LOG
195 echo >> $LOG
196}
197
198log_failure()
199{
200 echo
201 echo " ** $1!"
202 echo "** $1!" >> $LOG
203 echo >> $LOG
204}
205
206cnf_append()
207{
208 printf "%-30s := %s\n" "$1" "$2" >> $CNF
209}
210
211strip_l()
212{
213 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
214}
215
216strip_L()
217{
218 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
219}
220
221strip_I()
222{
223 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
224}
225
226prefix_I()
227{
228 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
229}
230
231check_avail()
232{
233 if [ -z "$1" ]; then
234 log_failure "$2 is empty"
235 fail $3
236 return 1
237 elif which_wrapper $1 > /dev/null; then
238 return 0
239 else
240 log_failure "$1 (variable $2) not found"
241 fail $3
242 return 1
243 fi
244}
245
246
247# Prepare a test
248test_header()
249{
250 echo "***** Checking $1 *****" >> $LOG
251 $ECHO_N "Checking for $1: "
252}
253
254
255# Compile a test
256# $1 compile flags/libs
257# $2 library name
258# $3 package name
259# $4 if this argument is 'nofatal', don't abort
260test_compile()
261{
262 echo "compiling the following source file:" >> $LOG
263 cat $ODIR.tmp_src.cc >> $LOG
264 echo "using the following command line:" >> $LOG
265 echo "$CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
266 $CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
267 if [ $? -ne 0 ]; then
268 if [ -z "$4" ]; then
269 echo
270 echo " $2 not found at $1 or $3 headers not found"
271 echo " Check the file $LOG for detailed error information."
272 fail
273 else
274 echo >> $LOG
275 echo >> $LOG
276 fi
277 return 1
278 fi
279 return 0
280}
281
282
283# Execute a compiled test binary
284test_execute()
285{
286 echo "executing the binary" >> $LOG
287 $ODIR.tmp_out > $ODIR.test_execute.log
288 rc=$?
289 cat $ODIR.test_execute.log | tee -a $LOG
290 if [ $rc -ne 0 ]; then
291 fail $1
292 return 1
293 fi
294 echo >> $LOG
295 echo >> $LOG
296 return 0
297}
298
299
300# Execute a compiled test binary
301test_execute_path()
302{
303 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
304 LD_LIBRARY_PATH=$1 $ODIR.tmp_out > $ODIR.test_execute.log
305 rc=$?
306 cat $ODIR.test_execute.log | tee -a $LOG
307 if [ $rc -ne 0 ]; then
308 fail
309 return 1
310 fi
311 echo >> $LOG
312 echo >> $LOG
313 return 0
314}
315
316
317#
318# Check for OS, MACHINE, CPU
319#
320check_environment()
321{
322 test_header environment
323 BUILD_CPU=`uname -m`
324 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
325 case "$BUILD_CPU" in
326 i[3456789]86|x86|i86pc)
327 BUILD_MACHINE='x86'
328 LIB='lib'
329 ;;
330 x86_64|amd64)
331 BUILD_MACHINE='amd64'
332 BUILD_CPU='k8'
333 if [ "$OS" != "solaris" ]; then
334 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
335 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
336 LIB='lib64'
337 else
338 # Solaris doesn't seem to subscribe to fhs, libs are usually in
339 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
340 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
341 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
342 # have to make sure the */bin/amd64 dirs are searched before the */bin
343 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
344 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
345 echo "old PATH: $PATH" >> $LOG
346 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
347 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
348 export PATH
349 echo "new PATH: $PATH" >> $LOG
350 LIB='lib/64'
351 fi
352 ;;
353 *)
354 log_failure "Cannot determine system"
355 exit 1
356 ;;
357 esac
358 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
359 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
360 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
361 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
362
363 echo "BUILD_PLATFORM=\"$OS\"" >> $ENV
364 echo "export BUILD_PLATFORM" >> $ENV
365 echo "BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
366 echo "export BUILD_PLATFORM_ARCH" >> $ENV
367 echo "BUILD_TARGET=\"$OS\"" >> $ENV
368 echo "export BUILD_TARGET" >> $ENV
369 echo "BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
370 echo "export BUILD_TARGET_ARCH" >> $ENV
371 echo "BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
372 echo "export BUILD_TARGET_CPU" >> $ENV
373 echo "BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
374 echo "export BUILD_TYPE" >> $ENV
375}
376
377#
378# Check for gcc with version >= 3.2.
379# We depend on a working gcc, if we fail terminate in every case.
380#
381check_gcc()
382{
383 test_header gcc
384 if check_avail "$CC" CC really; then
385 cc_ver=`$CC -dumpversion` 2>/dev/null
386 if [ $? -ne 0 ]; then
387 log_failure "cannot execute '$CC -dumpversion'"
388 fail really
389 fi
390 if check_avail "$CXX" CXX really; then
391 cxx_ver=`$CXX -dumpversion` 2>/dev/null
392 if [ $? -ne 0 ]; then
393 log_failure "cannot execute '$CXX -dumpversion'"
394 fail really
395 fi
396 cc_maj=`echo $cc_ver|cut -d. -f1`
397 cc_min=`echo $cc_ver|cut -d. -f2`
398 if [ "x$cc_ver" != "x$cxx_ver" ]; then
399 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
400 fail really
401 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "$OS" = "darwin" ]; then
402 log_success "found version $cc_ver"
403 # gcc-4.0 is allowed for Darwin only
404 elif [ $cc_maj -lt 3 \
405 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
406 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
407 -o \( $cc_maj -eq 4 -a $cc_min -gt 5 \) \
408 -o $cc_maj -gt 4 ]; then
409 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<5"
410 fail really
411 else
412 log_success "found version $cc_ver"
413 fi
414 if [ "$BUILD_MACHINE" = "amd64" ]; then
415 [ -z "$CC32" ] && CC32="$CC -m32"
416 [ -z "$CXX32" ] && CXX32="$CXX -m32"
417 else
418 [ -z "$CC32" ] && CC32="$CC"
419 [ -z "$CXX32" ] && CXX32="$CXX"
420 fi
421 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
422 [ -z "$CC64" ] && CC64="$CC -m64"
423 [ -z "$CXX64" ] && CXX64="$CXX -m64"
424 fi
425 if [ "$TARGET_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 0 ]; then
426 CC32="undefined"
427 CXX32="undefined"
428 fi
429 if [ "$CC" != "gcc" ]; then
430 cnf_append "TOOL_GCC3_CC" "$CC"
431 cnf_append "TOOL_GCC3_AS" "$CC"
432 cnf_append "TOOL_GCC3_LD" "$CC"
433 cnf_append "TOOL_GXX3_CC" "$CC"
434 cnf_append "TOOL_GXX3_AS" "$CC"
435 fi
436 if [ "$CXX" != "g++" ]; then
437 cnf_append "TOOL_GCC3_CXX" "$CXX"
438 cnf_append "TOOL_GXX3_CXX" "$CXX"
439 cnf_append "TOOL_GXX3_LD" "$CXX"
440 fi
441 if [ "$CC32" != "gcc -m32" -a "$CC32" != "undefined" ]; then
442 cnf_append "TOOL_GCC32_CC" "$CC32"
443 cnf_append "TOOL_GCC32_AS" "$CC32"
444 cnf_append "TOOL_GCC32_LD" "$CC32"
445 cnf_append "TOOL_GXX32_CC" "$CC32"
446 cnf_append "TOOL_GXX32_AS" "$CC32"
447 fi
448 if [ "$CXX32" != "g++ -m32" -a "$CXX32" != "undefined" ]; then
449 cnf_append "TOOL_GCC32_CXX" "$CXX32"
450 cnf_append "TOOL_GXX32_CXX" "$CXX32"
451 cnf_append "TOOL_GXX32_LD" "$CXX32"
452 fi
453 # this isn't not necessary, there is not such tool.
454 if [ -n "$CC64" ]; then
455 cnf_append "TOOL_GCC64_CC" "$CC64"
456 cnf_append "TOOL_GCC64_AS" "$CC64"
457 cnf_append "TOOL_GCC64_LD" "$CC64"
458 cnf_append "TOOL_GXX64_CC" "$CC64"
459 cnf_append "TOOL_GXX64_AS" "$CC64"
460 fi
461 if [ -n "$CXX64" ]; then
462 cnf_append "TOOL_GCC64_CXX" "$CXX64"
463 cnf_append "TOOL_GXX64_CXX" "$CXX64"
464 cnf_append "TOOL_GXX64_LD" "$CXX64"
465 fi
466 # Solaris sports a 32-bit gcc/g++.
467 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
468 [ "$CC" = "gcc" ] && CC="gcc -m64"
469 [ "$CXX" = "g++" ] && CXX="g++ -m64"
470 fi
471 fi
472 fi
473}
474
475
476#
477# Check for the bcc compiler, needed for compiling the BIOS
478#
479check_bcc()
480{
481 test_header bcc
482 if check_avail "$BCC" BCC; then
483 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
484 if [ $? -ne 0 ]; then
485 log_failure "not found"
486 fail
487 else
488 echo "compiling the following source file:" >> $LOG
489 cat > $ODIR.tmp_src.c << EOF
490int foo(a)
491 int a;
492{
493 return 0;
494}
495EOF
496 cat $ODIR.tmp_src.c >> $LOG
497 bcc_path=`which_wrapper $BCC`
498 bcc_dir="`dirname $bcc_path`/"
499 echo "using the following command line:" >> $LOG
500 echo "$BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
501 $BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
502 if [ $? -ne 0 ]; then
503 log_failure "not found"
504 fail
505 else
506 log_success "found version $bcc_ver"
507 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
508 fi
509 unset bcc_path
510 unset bcc_dir
511 fi
512 fi
513}
514
515
516#
517# Check for the as86 assembler, needed for compiling the BIOS
518#
519check_as86()
520{
521 test_header as86
522 if check_avail "$AS86" AS86; then
523 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
524 if [ $? -ne 0 ]; then
525 log_failure "not found"
526 fail
527 else
528 log_success "found version $as86_ver"
529 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
530 fi
531 fi
532}
533
534
535#
536# Check for yasm, needed to compile assembler files
537#
538check_yasm()
539{
540 test_header yasm
541 if check_avail "$YASM" YASM; then
542 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
543 if [ $? -ne 0 ]; then
544 log_failure "not found"
545 fail
546 else
547 yasm_maj=`echo $yasm_ver|cut -d. -f1`
548 yasm_min=`echo $yasm_ver|cut -d. -f2`
549 yasm_rev=`echo $yasm_ver|cut -d. -f3`
550 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
551 if [ $yasm_ver_mul -lt 501 ]; then
552 log_failure "found version $yasm_ver, expected at least 0.5.1"
553 fail
554 else
555 log_success "found version $yasm_ver"
556 fi
557 fi
558 fi
559}
560
561
562#
563# Check for the iasl ACPI compiler, needed to compile vbox.dsl
564#
565check_iasl()
566{
567 test_header iasl
568 if check_avail "$IASL" IASL; then
569 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
570 if [ $? -ne 0 ]; then
571 log_failure "not found"
572 fail
573 else
574 log_success "found version $iasl_ver"
575 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
576 fi
577 fi
578}
579
580
581#
582# Check for xsltproc, needed by Main
583#
584check_xsltproc()
585{
586 test_header xslt
587 if check_avail "$XSLTPROC" XSLTPROC; then
588 xsltproc_ver=`$XSLTPROC --version`
589 if [ $? -ne 0 ]; then
590 log_failure "not found"
591 fail
592 else
593 log_success "found"
594 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
595 fi
596 fi
597}
598
599
600#
601# Check for mkisofs, needed to build the CDROM image containing the additions
602#
603check_mkisofs()
604{
605 test_header mkisofs
606 if which_wrapper $GENISOIMAGE > /dev/null; then
607 mkisofs_ver=`$GENISOIMAGE --version`
608 if [ $? -ne 0 ]; then
609 log_failure "not found"
610 fail
611 else
612 log_success "found $mkisofs_ver"
613 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
614 fi
615 elif check_avail "$MKISOFS" MKISOFS; then
616 mkisofs_ver=`$MKISOFS --version`
617 if [ $? -ne 0 ]; then
618 log_failure "not found"
619 fail
620 else
621 log_success "found $mkisofs_ver"
622 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
623 fi
624 fi
625}
626
627
628#
629# Check for libxml2, needed by VBoxSettings and Runtime.
630# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
631#
632check_libxml2()
633{
634 if [ -z "$BUILD_LIBXML2" ]; then
635 test_header libxml2
636 if which_wrapper pkg-config > /dev/null; then
637 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
638 if [ $? -ne 0 ]; then
639 log_failure "not found"
640 fail
641 else
642 FLGXML2=`pkg-config libxml-2.0 --cflags`
643 INCXML2=`strip_I "$FLGXML2"`
644 LIBXML2=`pkg-config libxml-2.0 --libs`
645 cat > $ODIR.tmp_src.cc << EOF
646#include <cstdio>
647#include <libxml/xmlversion.h>
648extern "C" int main(void)
649{
650 printf("found version %s", LIBXML_DOTTED_VERSION);
651#if LIBXML_VERSION >= 20626
652 printf(", OK.\n");
653 return 0;
654#else
655 printf(", expected version 2.6.26 or higher\n");
656 return 1;
657#endif
658}
659EOF
660 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
661 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
662 if test_execute; then
663 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
664 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
665 fi
666 fi
667 fi
668 elif which_wrapper xml2-config; then
669 libxml2_ver=`xml2-config --version`
670 if [ $? -ne 0 ]; then
671 log_failure "not found"
672 fail
673 else
674 log_success "found version $libxml2_ver"
675 FLGXML2=`xml2-config --cflags`
676 INCXML2=`strip_I "$FLGXML2"`
677 LIBXML2=`xml2-config --libs`
678 cat > $ODIR.tmp_src.cc << EOF
679#include <cstdio>
680#include <libxml/xmlversion.h>
681extern "C" int main(void)
682{
683 printf("found version %s", LIBXML_DOTTED_VERSION);
684#if LIBXML_VERSION >= 20626
685 printf(", OK.\n");
686 return 0;
687#else
688 printf(", expected version 2.6.26 or higher\n");
689 return 1;
690#endif
691}
692EOF
693 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
694 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
695 if test_execute; then
696 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
697 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
698 fi
699 fi
700 fi
701 else
702 log_failure "neither pkg-config nor xml2-config found"
703 fail
704 fi
705 fi
706}
707
708
709#
710# Check for libxslt, needed by VBoxSettings. For now we depend on 1.1.15,
711# as Solaris right now has no newer version and it definitely works.
712# 1.1.17 is available on Ubuntu Edgy which fulfils the minimal libxml2
713# requirement (2.6.26).
714#
715check_libxslt()
716{
717 if [ -z "$BUILD_LIBXSLT" ]; then
718 test_header libxslt
719 if which_wrapper pkg-config > /dev/null; then
720 libxslt_ver=`pkg-config libxslt --modversion 2>> $LOG`
721 if [ $? -ne 0 ]; then
722 log_failure "not found"
723 fail
724 else
725 FLGXSLT=`pkg-config libxslt --cflags`
726 INCXSLT=`strip_I "$FLGXSLT"`
727 LIBXSLT=`pkg-config libxslt --libs`
728 cat > $ODIR.tmp_src.cc << EOF
729#include <cstdio>
730#include <libxslt/xsltconfig.h>
731extern "C" int main(void)
732{
733 printf("found version %s", LIBXSLT_DOTTED_VERSION);
734#if LIBXSLT_VERSION >= 10117
735 printf(", OK.\n");
736 return 0;
737#else
738 printf(", expected version 1.1.17 or higher\n");
739 return 1;
740#endif
741}
742EOF
743 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
744 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
745 if test_execute; then
746 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
747 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
748 fi
749 fi
750 fi
751 elif which_wrapper xslt-config; then
752 libxslt_ver=`xslt-config --version`
753 if [ $? -ne 0 ]; then
754 log_failure "not found"
755 fail
756 else
757 log_success "found version $libxslt_ver"
758 FLGXSLT=`xslt-config --cflags`
759 INCXSLT=`strip_I "$FLGXSLT"`
760 LIBXSLT=`xslt-config --libs`
761 cat > $ODIR.tmp_src.cc << EOF
762#include <cstdio>
763#include <libxslt/xsltconfig.h>
764extern "C" int main(void)
765{
766 printf("found version %s", LIBXSLT_DOTTED_VERSION);
767#if LIBXSLT_VERSION >= 10117
768 printf(", OK.\n");
769 return 0;
770#else
771 printf(", expected version 1.1.17 or higher\n");
772 return 1;
773#endif
774}
775EOF
776 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
777 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
778 if test_execute; then
779 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
780 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
781 fi
782 fi
783 fi
784 else
785 log_failure "neither pkg-config nor xslt-config found"
786 fail
787 fi
788 fi
789}
790
791
792#
793# Check for libIDL, needed by xpcom
794#
795check_libidl()
796{
797 test_header libIDL
798
799 if which_wrapper libIDL-config-2 > /dev/null; then
800 libidl_ver=`libIDL-config-2 --version`
801 if [ $? -ne 0 ]; then
802 log_failure "not found"
803 fail
804 else
805 log_success "found version $libidl_ver"
806 cnf_append "VBOX_LIBIDL_CONFIG" \
807 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
808 fi
809 elif check_avail "libIDL-config" libIDL-config; then
810 libidl_ver=`libIDL-config --version`
811 if [ $? -ne 0 ]; then
812 log_failure "not found"
813 fail
814 else
815 log_success "found version $libidl_ver"
816 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
817 fi
818 fi
819}
820
821
822#
823# Check for openssl, needed for RDP and S3
824#
825check_ssl()
826{
827 if [ -z "$BUILD_LIBSSL" ]; then
828 test_header ssl
829 cat > $ODIR.tmp_src.cc << EOF
830#include <cstdio>
831#include <openssl/opensslv.h>
832extern "C" int main(void)
833{
834 printf("found version %s", OPENSSL_VERSION_TEXT);
835#if OPENSSL_VERSION_NUMBER >= 0x00908000
836 printf(", OK.\n");
837 return 0;
838#else
839 printf(", expected version 0.9.8 or higher\n");
840 return 1;
841#endif
842}
843EOF
844 if test_compile "$INCCRYPTO $LIBCRYPTO" libcrypto openssl; then
845 if test_execute nofatal; then
846 cnf_append "SDK_VBOX_OPENSSL_INCS" "`strip_I "$INCCRYPTO"`"
847 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
848 fi
849 fi
850 fi
851}
852
853
854#
855# Check for pthread, needed by VBoxSVC, frontends, ...
856#
857check_pthread()
858{
859 test_header pthread
860 cat > $ODIR.tmp_src.cc << EOF
861#include <cstdio>
862#include <pthread.h>
863extern "C" int main(void)
864{
865 pthread_mutex_t mutex;
866 if (pthread_mutex_init(&mutex, NULL)) {
867 printf("pthread_mutex_init() failed\n");
868 return 1;
869 }
870 if (pthread_mutex_lock(&mutex)) {
871 printf("pthread_mutex_lock() failed\n");
872 return 1;
873 }
874 if (pthread_mutex_unlock(&mutex)) {
875 printf("pthread_mutex_unlock() failed\n");
876 return 1;
877 }
878 printf("found, OK.\n");
879}
880EOF
881 if test_compile $LIBPTHREAD pthread pthread; then
882 if test_execute; then
883 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
884 fi
885 fi
886}
887
888
889#
890# Check for zlib, needed by VBoxSVC, Runtime, ...
891#
892check_z()
893{
894 test_header zlib
895 cat > $ODIR.tmp_src.cc << EOF
896#include <cstdio>
897#include <zlib.h>
898extern "C" int main(void)
899{
900 printf("found version %s", ZLIB_VERSION);
901#if ZLIB_VERNUM >= 0x1210
902 printf(", OK.\n");
903 return 0;
904#else
905 printf(", expected version 1.2.1 or higher\n");
906 return 1;
907#endif
908}
909EOF
910 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
911 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
912 if test_execute; then
913 echo "if1of (\$(KBUILD_TARGET),darwin freebsd linux solaris)" >> $CNF
914 cnf_append " SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
915 cnf_append " SDK_VBOX_ZLIB_INCS" "$INCZ"
916 echo "endif" >> $CNF
917 fi
918 fi
919}
920
921
922#
923# Check for libpng, needed by kchmviewer
924#
925check_png()
926{
927 test_header libpng
928 cat > $ODIR.tmp_src.cc << EOF
929#include <cstdio>
930#include <png.h>
931extern "C" int main(void)
932{
933 printf("found version %s", PNG_LIBPNG_VER_STRING);
934#if PNG_LIBPNG_VER >= 10205
935 printf(", OK.\n");
936 return 0;
937#else
938 printf(", expected version 1.2.5 or higher\n");
939 return 1;
940#endif
941}
942EOF
943 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
944 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
945 if test_execute; then
946 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
947 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
948 fi
949 fi
950}
951
952#
953# Check for libcurl, needed by S3
954#
955check_curl()
956{
957 if [ -z "$BUILD_LIBCURL" ]; then
958 test_header libcurl
959 cat > $ODIR.tmp_src.cc << EOF
960#include <cstdio>
961#include <curl/curl.h>
962extern "C" int main(void)
963{
964 printf("found version %s", LIBCURL_VERSION);
965#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR + LIBCURL_VERSION_PATCH >= 71601
966 printf(", OK.\n");
967 return 0;
968#else
969 printf(", expected version 7.16.1 or higher\n");
970 return 1;
971#endif
972}
973EOF
974 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
975 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
976 if test_execute; then
977 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
978 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
979 fi
980 fi
981 fi
982}
983
984
985#
986# Check for pam, needed by VRDPAuth
987# Version 79 was introduced in 9/2005, do we support older versions?
988# Debian/sarge uses 76
989# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
990#
991check_pam()
992{
993 test_header pam
994 cat > $ODIR.tmp_src.cc << EOF
995#include <cstdio>
996#include <security/pam_appl.h>
997extern "C" int main(void)
998{
999 printf("found version %d", __LIBPAM_VERSION);
1000 if (__LIBPAM_VERSION >= 76)
1001 {
1002 printf(", OK.\n");
1003 return 0;
1004 }
1005 else
1006 {
1007 printf(", expected version 76 or higher\n");
1008 return 1;
1009 }
1010}
1011EOF
1012 if test_compile "-lpam" pam pam nofatal; then
1013 if test_execute nofatal; then
1014 return 0;
1015 fi
1016 fi
1017 echo "not found."
1018 test_header linux_pam
1019 cat > $ODIR.tmp_src.cc << EOF
1020#include <cstdio>
1021#include <security/pam_appl.h>
1022extern "C" int main(void)
1023{
1024 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1025 if (__LINUX_PAM__ >= 1)
1026 {
1027 printf(", OK.\n");
1028 return 0;
1029 }
1030 else
1031 {
1032 printf(", expected version 1.0 or higher\n");
1033 return 1;
1034 }
1035}
1036EOF
1037 if test_compile "-lpam" pam pam; then
1038 test_execute
1039 fi
1040}
1041
1042
1043#
1044# Check for the SDL library, needed by VBoxSDL and VirtualBox
1045# We depend at least on version 1.2.7
1046#
1047check_sdl()
1048{
1049 test_header SDL
1050 if [ "$OS" = "darwin" ]; then
1051 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1052 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1053 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1054 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1055 fi
1056 if [ -n "$PATH_SDK_LIBSDL" ]; then
1057 foundsdl=1
1058 INCSDL="$PATH_SDK_LIBSDL/Headers"
1059 FLDSDL="-framework SDL"
1060 else
1061 log_failure "SDL framework not found"
1062 fail
1063 fi
1064 else
1065 if which_wrapper sdl-config > /dev/null; then
1066 FLGSDL=`sdl-config --cflags`
1067 INCSDL=`strip_I "$FLGSDL"`
1068 LIBSDL=`sdl-config --libs`
1069 LIBSDLMAIN="-lSDLmain"
1070 FLDSDL=
1071 foundsdl=1
1072 fi
1073 fi
1074 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1075 if [ -n "$foundsdl" ]; then
1076 cat > $ODIR.tmp_src.cc << EOF
1077#include <cstdio>
1078#include <SDL.h>
1079#include <SDL_main.h>
1080#undef main
1081extern "C" int main(int argc, char** argv)
1082{
1083 printf("found version %d.%d.%d",
1084 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1085#if SDL_VERSION_ATLEAST(1,2,7)
1086 printf(", OK.\n");
1087 return 0;
1088#else
1089 printf(", expected version 1.2.7 or higher\n");
1090 return 1;
1091#endif
1092}
1093EOF
1094 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1095 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1096 if test_execute; then
1097 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1098 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1099 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1100 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1101 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1102 fi
1103 fi
1104 else
1105 log_failure "not found"
1106 fail
1107 fi
1108}
1109
1110
1111#
1112# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1113#
1114check_sdl_ttf()
1115{
1116 test_header SDL_ttf
1117 cat > $ODIR.tmp_src.cc << EOF
1118#include <cstdio>
1119#include <SDL_ttf.h>
1120#ifndef SDL_TTF_MAJOR_VERSION
1121#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1122#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1123#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1124#endif
1125extern "C" int main(void)
1126{
1127 printf("found version %d.%d.%d",
1128 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1129#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1130 printf(", OK.\n");
1131 return 0;
1132#else
1133 printf(", expected version 2.0.6 or higher\n");
1134 return 1;
1135#endif
1136}
1137EOF
1138 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1139 if ! test_execute nofatal; then
1140 cnf_append "VBOX_WITH_SECURELABEL" ""
1141 fi
1142 else
1143 echo "not found -- disabling VBoxSDL secure label."
1144 cnf_append "VBOX_WITH_SECURELABEL" ""
1145 fi
1146}
1147
1148
1149#
1150# Check for libasound, needed by the ALSA audio backend
1151#
1152check_alsa()
1153{
1154 test_header ALSA
1155 cat > $ODIR.tmp_src.cc << EOF
1156#include <cstdio>
1157#include <alsa/asoundlib.h>
1158extern "C" int main(void)
1159{
1160 printf("found version %d.%d.%d",
1161 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1162#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1163 printf(", OK.\n");
1164 return 0;
1165#else
1166 printf(", expected version 1.0.6 or higher\n");
1167 return 1;
1168#endif
1169}
1170EOF
1171 if test_compile "-lasound" asound asound; then
1172 test_execute
1173 fi
1174}
1175
1176
1177#
1178# Check for PulseAudio
1179#
1180check_pulse()
1181{
1182 test_header "PulseAudio"
1183 cat > $ODIR.tmp_src.cc << EOF
1184#include <cstdio>
1185#include <pulse/version.h>
1186extern "C" int main(void)
1187{
1188 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1189#if PA_API_VERSION >= 9
1190 printf(", OK.\n");
1191 return 0;
1192#else
1193 printf(", expected version 0.9.0 (API version 9) or higher\n");
1194 return 1;
1195#endif
1196}
1197EOF
1198 if test_compile "$INCPULSE $LIBPULSE -lpulse" pulse pulse; then
1199 test_execute
1200 fi
1201}
1202
1203
1204#
1205# Check for the X libraries (Xext, X11)
1206#
1207check_x()
1208{
1209 test_header "X libraries"
1210 cat > $ODIR.tmp_src.cc << EOF
1211#include <cstdio>
1212#include <X11/Xlib.h>
1213extern "C" int main(void)
1214{
1215 Display *dpy;
1216 int scrn_num;
1217 Screen *scrn;
1218 Window win;
1219
1220 dpy = XOpenDisplay(NULL);
1221 scrn_num = DefaultScreen(dpy);
1222 scrn = ScreenOfDisplay(dpy, scrn_num);
1223 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1224 0, 16, InputOutput, CopyFromParent, 0, NULL);
1225 XDestroyWindow(dpy, win);
1226 XCloseDisplay(dpy);
1227}
1228EOF
1229 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1230 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1231 log_success "found"
1232 fi
1233}
1234
1235
1236#
1237# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
1238#
1239check_xcursor()
1240{
1241 test_header Xcursor
1242 cat > $ODIR.tmp_src.cc << EOF
1243#include <cstdio>
1244#include <X11/Xlib.h>
1245#include <X11/Xcursor/Xcursor.h>
1246extern "C" int main(void)
1247{
1248 XcursorImage *cursor = XcursorImageCreate (10, 10);
1249 XcursorImageDestroy(cursor);
1250 return 0;
1251}
1252EOF
1253 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1254 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1255 log_success "found"
1256 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1257 fi
1258}
1259
1260
1261#
1262# Check for the Xinerama library, needed by the Qt GUI
1263#
1264check_xinerama()
1265{
1266 test_header Xinerama
1267 cat > $ODIR.tmp_src.cc << EOF
1268#include <X11/Xlib.h>
1269#include <X11/extensions/Xinerama.h>
1270extern "C" int main(void)
1271{
1272 Display *dpy;
1273 Bool flag;
1274 dpy = XOpenDisplay(NULL);
1275 if (dpy)
1276 {
1277 flag = XineramaIsActive(dpy);
1278 XCloseDisplay(dpy);
1279 }
1280}
1281EOF
1282 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1283 if test_compile "$LIBX11 $LIBXINERAMA $I_INCX11" Xinerama Xinerama; then
1284 log_success "found"
1285 fi
1286}
1287
1288
1289#
1290# Check for the Xinerama library, needed by the Qt GUI
1291#
1292check_xrandr()
1293{
1294 test_header Xrandr
1295 cat > $ODIR.tmp_src.cc << EOF
1296#include <X11/Xlib.h>
1297#include <X11/extensions/Xrandr.h>
1298extern "C" int main(void)
1299{
1300 Display *dpy;
1301 Bool flag;
1302 int major, minor;
1303 dpy = XOpenDisplay(NULL);
1304 if (dpy)
1305 {
1306 flag = XRRQueryVersion(dpy, &major, &minor);
1307 XCloseDisplay(dpy);
1308 }
1309}
1310EOF
1311 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1312 if test_compile "$LIBX11 $LIBXRANDR $I_INCX11" Xrandr Xrandr; then
1313 log_success "found"
1314 fi
1315}
1316
1317
1318#
1319# Check for OpenGL
1320#
1321check_opengl()
1322{
1323 # On darwin this is a on/off decision only
1324 if [ "$OS" = "darwin" ]; then
1325 test_header "OpenGL support"
1326 echo "enabled"
1327 cnf_append "VBOX_WITH_CROGL" "1"
1328 else
1329 check_xmu
1330 check_mesa
1331 fi
1332}
1333
1334
1335#
1336# Check for the Xmu library, needed by OpenGL
1337#
1338check_xmu()
1339{
1340 test_header Xmu
1341 cat > $ODIR.tmp_src.cc << EOF
1342#include <cstdio>
1343#include <X11/Xatom.h>
1344#include <X11/Xlib.h>
1345#include <X11/Xutil.h>
1346#include <X11/Xmu/StdCmap.h>
1347extern "C" int main(void)
1348{
1349 Display *dpy;
1350 int scrn_num;
1351 Screen *scrn;
1352
1353 dpy = XOpenDisplay(NULL);
1354 if (dpy)
1355 {
1356 scrn_num = DefaultScreen(dpy);
1357 scrn = ScreenOfDisplay(dpy, scrn_num);
1358 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1359 24, XA_RGB_DEFAULT_MAP, False, True);
1360 printf("Status = %x\n", status);
1361 XCloseDisplay(dpy);
1362 }
1363 return 0;
1364}
1365EOF
1366 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1367 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1368 log_success "found"
1369 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1370 fi
1371}
1372
1373#
1374# Check for Mesa, needed by OpenGL
1375#
1376check_mesa()
1377{
1378 test_header "Mesa / GLU"
1379 cat > $ODIR.tmp_src.cc << EOF
1380#include <cstdio>
1381#include <X11/Xlib.h>
1382#include <GL/glx.h>
1383#include <GL/glu.h>
1384extern "C" int main(void)
1385{
1386 Display *dpy;
1387 int major, minor;
1388
1389 dpy = XOpenDisplay(NULL);
1390 if (dpy)
1391 {
1392 if (glXQueryVersion(dpy, &major, &minor))
1393 {
1394 printf("found version %u.%u, OK.\n", major, minor);
1395 return 0;
1396 }
1397 XCloseDisplay(dpy);
1398 }
1399 printf("found (inactive), OK.\n");
1400 return 0;
1401}
1402EOF
1403 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1404 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1405 [ $PASSIVE_MESA -eq 1 ] && unset DISPLAY
1406 test_execute
1407 fi
1408}
1409
1410
1411#
1412# Check for the Qt4 library, needed by the VirtualBox frontend
1413#
1414# Currently not fatal.
1415#
1416check_qt4()
1417{
1418 foundqt4=
1419 test_header Qt4
1420 if [ "$OS" = "darwin" ]; then
1421 # First check if there is the internal version of Qt. If yes nothing else
1422 # has to be done.
1423 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1424 for t in $QT_INTERNAL; do
1425 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1426 cnf_append "VBOX_WITH_QT4_SUN" "1"
1427 log_success "use internal version"
1428 return
1429 fi
1430 done
1431 # Now try the user provided directory and some of the standard directories.
1432 QT_TRIES="$QT4DIR /System/Library /Library"
1433 for t in $QT_TRIES; do
1434 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1435 PATH_SDK_QT4="$t"
1436 break
1437 fi
1438 done
1439 # Add the necessary params for building the test application
1440 if [ -n "$PATH_SDK_QT4" ]; then
1441 foundqt4=1
1442 INCQT4=-I$PATH_SDK_QT4/Frameworks/QtCore.framework/Headers
1443 LIBQT4=-F$PATH_SDK_QT4/Frameworks
1444 FLGQT4="-framework QtCore"
1445 else
1446 log_failure "Qt4 framework not found (can be disabled using --disable-qt4)"
1447 fail
1448 fi
1449 else
1450 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1451 # default is to use pkg-config
1452 if which_wrapper pkg-config > /dev/null; then
1453 # this braindead path is necessary for mdv2008.1
1454 qt4_ver=`\
1455 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1456 pkg-config QtCore --modversion 2>> $LOG`
1457 if [ $? -ne 0 ]; then
1458 log_failure "not found"
1459 fail
1460 else
1461 FLGQT4=`\
1462 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1463 pkg-config QtCore --cflags`
1464 INCQT4=`strip_I "$FLGQT4"`
1465 LIBQT4=`\
1466 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1467 PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 \
1468 pkg-config QtCore --libs`
1469 foundqt4=1
1470 fi
1471 else
1472 log_failure "pkg-config not found"
1473 fail
1474 fi
1475 else
1476 # do it the old way (e.g. user has specified QT4DIR)
1477 cat > $ODIR.tmp_src.cc << EOF
1478#include <cstdio>
1479#include <QtGlobal>
1480extern "C" int main(void)
1481{
1482 printf("found version %s", QT_VERSION_STR);
1483#if QT_VERSION >= 0x040400
1484 printf(", OK.\n");
1485 return 0;
1486#else
1487 printf(", expected version 4.4.0 or higher\n");
1488 return 1;
1489#endif
1490}
1491EOF
1492 for q in $QT4DIR; do
1493 INCQT4="$q/include $q/include/QtCore"
1494 FLGQT4="-DQT_SHARED"
1495 I_INCQT4=`prefix_I "$INCQT4"`
1496 LIBQT4="-L$q/lib -lQtCoreVBox"
1497 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1498 foundqt4=2
1499 break;
1500 fi
1501 LIBQT4="-L$q/lib -lQtCore"
1502 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1503 foundqt4=1
1504 break;
1505 fi
1506 done
1507 fi
1508 fi
1509 if [ -n "$foundqt4" ]; then
1510 cat > $ODIR.tmp_src.cc << EOF
1511#include <cstdio>
1512#include <QtGlobal>
1513extern "C" int main(void)
1514{
1515 printf("found version %s", QT_VERSION_STR);
1516#if QT_VERSION >= 0x040400
1517 printf(", OK.\n");
1518 return 0;
1519#else
1520 printf(", expected version 4.4.0 or higher\n");
1521 return 1;
1522#endif
1523}
1524EOF
1525 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1526 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1527 if test_execute_path "`strip_L "$LIBQT4"`"; then
1528 if [ "$OS" = "darwin" ]; then
1529 # Successful build & run the test application so add the necessary
1530 # params to AutoConfig.kmk
1531 cnf_append "PATH_SDK_QT4_INC" "$PATH_SDK_QT4/Frameworks"
1532 cnf_append "PATH_SDK_QT4_LIB" "$PATH_SDK_QT4/Frameworks"
1533 cnf_append "PATH_SDK_QT4" "$PATH_SDK_QT4/Frameworks"
1534 # Check for the moc tool in the Qt directory found & some standard
1535 # directories.
1536 for q in $PATH_SDK_QT4 /usr /Developer/Tools/Qt; do
1537 if which_wrapper "$q/bin/moc" > /dev/null; then
1538 cnf_append "PATH_TOOL_QT4" "$q"
1539 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1540 fi
1541 done
1542 else
1543 # strip .../QtCore as we add components ourself
1544 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1545 # store only the first path, remove all other pathes
1546 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1547 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1548 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1549 cnf_append "SDK_QT4_LIBPATH" "`strip_L "$LIBQT4"`"
1550 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1551 # this is not quite right since the qt libpath does not have to be first...
1552 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1553 if [ "$foundqt4" = "2" ]; then
1554 cnf_append "VBOX_WITH_QT4_SUN" "1"
1555 fi
1556 test_header "Qt4 devtools"
1557 for q in $QT4DIR; do
1558 # first try it with a suffix, some platforms use that
1559 if which_wrapper "$q/bin/moc-qt4" > /dev/null; then
1560 moc_ver=`$q/bin/moc-qt4 -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1561 if [ $? -ne 0 ]; then
1562 log_failure "not found"
1563 fail
1564 else
1565 log_success "found version $moc_ver"
1566 cnf_append "VBOX_PATH_QT4" "$q"
1567 cnf_append "PATH_SDK_QT4" "$q"
1568 cnf_append "PATH_TOOL_QT4" "$q"
1569 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1570 cnf_append "TOOL_QT4_BIN_SUFF" "-qt4"
1571 return
1572 fi
1573 elif which_wrapper "$q/bin/moc" > /dev/null; then
1574 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1575 if [ $? -ne 0 ]; then
1576 log_failure "not found"
1577 fail
1578 else
1579 log_success "found version $moc_ver"
1580 cnf_append "VBOX_PATH_QT4" "$q"
1581 cnf_append "PATH_SDK_QT4" "$q"
1582 cnf_append "PATH_TOOL_QT4" "$q"
1583 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1584 return
1585 fi
1586 fi
1587 done
1588 fi
1589 fi
1590 else
1591 log_failure "not found"
1592 fail
1593 fi
1594 else
1595 log_failure "not found"
1596 fail
1597 fi
1598}
1599
1600
1601#
1602# Check whether static libstdc++ is installed. This library is required
1603# for the Linux guest additions.
1604#
1605check_staticlibstdcxx()
1606{
1607 test_header "static stc++ library"
1608 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1609 cat > $ODIR.tmp_src.cc << EOF
1610#include <string>
1611
1612extern "C" int main(void)
1613{
1614 std::string s = "test";
1615 return 0;
1616}
1617EOF
1618 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1619 log_success "found"
1620 fi
1621}
1622
1623
1624#
1625# Check for Linux sources
1626#
1627check_linux()
1628{
1629 test_header "Linux kernel sources"
1630 cat > $ODIR.tmp_src.c << EOF
1631#include <linux/version.h>
1632int printf(const char *format, ...);
1633int main(void)
1634{
1635 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1636 (LINUX_VERSION_CODE % 65536) / 256,
1637 LINUX_VERSION_CODE % 256);
1638#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1639 printf(", OK.\n");
1640 return 0;
1641#else
1642 printf(", expected version 2.4.0 or higher\n");
1643 return 1;
1644#endif
1645}
1646EOF
1647 echo "compiling the following source file:" >> $LOG
1648 cat $ODIR.tmp_src.c >> $LOG
1649 echo "using the following command line:" >> $LOG
1650 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1651 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1652 if [ $? -ne 0 ]; then
1653 echo
1654 echo " Linux kernel headers not found at $LINUX"
1655 echo " Check the file $LOG for detailed error information."
1656 fail
1657 else
1658 if test_execute; then
1659 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1660 fi
1661 fi
1662}
1663
1664
1665#
1666# Check for kchmviewer, needed to display the online help
1667# (unused as we ship kchmviewer)
1668#
1669check_kchmviewer()
1670{
1671 test_header kchmviewer
1672 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1673 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1674 if [ $? -ne 0 ]; then
1675 log_failure "not found"
1676 fail
1677 else
1678 log_success "found version $kchmviewer_ver"
1679 fi
1680 fi
1681}
1682
1683
1684#
1685# Check for the kBuild tools, we don't support GNU make
1686#
1687check_kbuild()
1688{
1689 test_header kBuild
1690 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1691 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1692 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1693 echo "export PATH_KBUILD" >> $ENV
1694 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1695 echo "export PATH_DEVTOOLS" >> $ENV
1696 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1697 echo "export PATH_KBUILD_BIN" >> $ENV
1698 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1699 if [ "$OS" = "solaris" ]; then
1700 # Because of sh being non-default shell in Solaris we need to export PATH again when
1701 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1702 echo "PATH=\"$ORGPATH\"" >> $ENV
1703 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1704 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1705 else
1706 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1707 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1708 fi
1709 echo "export PATH" >> $ENV
1710 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1711 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1712 elif [ "$OS.$BUILD_MACHINE" = "darwin.amd64" ]; then
1713 # Currently there are no amd64 kBuild bins. So use the x86 variant in any case.
1714 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.x86"
1715 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1716 echo "export PATH_KBUILD" >> $ENV
1717 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1718 echo "export PATH_DEVTOOLS" >> $ENV
1719 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.x86\"" >> $ENV
1720 echo "PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1721 echo "export PATH_KBUILD_BIN" >> $ENV
1722 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1723 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1724 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1725 echo "export PATH" >> $ENV
1726 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1727 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1728 elif check_avail "kmk" KBUILDDIR really; then
1729 # check for installed kBuild
1730 KBUILD_SED="`which_wrapper kmk_sed`"
1731 else
1732 fail
1733 fi
1734 log_success "found"
1735}
1736
1737
1738#
1739# Check for compiler.h
1740# Some Linux distributions include "compiler.h" in their libc linux
1741# headers package, some don't. Most don't need it, building might (!)
1742# not succeed on openSUSE without it.
1743#
1744# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1745#
1746check_compiler_h()
1747{
1748 test_header compiler.h
1749 if ! test -f "/usr/include/linux/compiler.h"; then
1750 log_success "compiler.h not found"
1751 else
1752 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1753 log_success "compiler.h found"
1754 fi
1755}
1756
1757#
1758# Check for libcap.
1759# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1760# sockets for doing ICMP requests.
1761#
1762check_libcap()
1763{
1764 test_header "libcap library"
1765 cat > $ODIR.tmp_src.cc << EOF
1766#include <cstdio>
1767#include <sys/types.h>
1768#include <sys/capability.h>
1769
1770extern "C" int main(void)
1771{
1772 char buf[1024];
1773 cap_t caps = cap_get_proc();
1774 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1775 return 0;
1776}
1777EOF
1778 if test_compile $LIBCAP libcap libcap; then
1779 if test_execute; then
1780 log_success "found"
1781 fi
1782 fi
1783}
1784
1785#
1786# Check if we are able to build 32-bit applications (needed for the guest additions)
1787#
1788check_32bit()
1789{
1790 test_header "32-bit support"
1791 cat > $ODIR.tmp_src.c << EOF
1792#include <stdint.h>
1793int main(void)
1794{
1795 return 0;
1796}
1797EOF
1798 echo "compiling the following source file:" >> $LOG
1799 cat $ODIR.tmp_src.c >> $LOG
1800 echo "using the following command line:" >> $LOG
1801 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1802 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1803 if [ $? -ne 0 ]; then
1804 echo
1805 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1806 echo " Check the file $LOG for detailed error information."
1807 fail
1808 fi
1809 log_success ""
1810}
1811
1812
1813#
1814# Check for Python
1815#
1816check_python()
1817{
1818 test_header "Python support"
1819
1820 # On darwin this is a on/off decision only
1821 if [ "$OS" = "darwin" ]; then
1822 echo "enabled"
1823 cnf_append "VBOX_WITH_PYTHON" "1"
1824 return
1825 fi
1826
1827 cat > $ODIR.tmp_src.cc << EOF
1828#include <cstdio>
1829#include <Python.h>
1830extern "C" int main(void)
1831{
1832 Py_Initialize();
1833 printf("found version %s", PY_VERSION);
1834#if PY_VERSION_HEX >= 0x02030000
1835 printf(", OK.\n");
1836 return 0;
1837#else
1838 printf(", expected version 2.3 or higher\n");
1839 return 1;
1840#endif
1841}
1842EOF
1843 found=
1844# For Solaris we use libpython2.4 for compatibility with Solaris 10 and passing IPS pkg audit
1845 if [ "$OS" != "solaris" ]; then
1846 SUPPYTHONLIBS="python2.6 python2.5 python2.4 python2.3"
1847 else
1848 SUPPYTHONLIBS="python2.4"
1849 fi
1850 for p in $PYTHONDIR; do
1851 for d in $SUPPYTHONLIBS; do
1852 for b in lib64 lib/64 lib; do
1853 echo "compiling the following source file:" >> $LOG
1854 cat $ODIR.tmp_src.cc >> $LOG
1855 echo "using the following command line:" >> $LOG
1856 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1857 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1858 if [ $? -eq 0 ]; then
1859 found=1
1860 break
1861 fi
1862 done
1863 if [ -n "$found" ]; then break; fi
1864 done
1865 if [ -n "$found" ]; then break; fi
1866 done
1867 if [ -n "$found" ]; then
1868 if test_execute; then
1869 cnf_append "VBOX_WITH_PYTHON" "1"
1870 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1871 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1872 else
1873 log_failure "not found"
1874 fail
1875 fi
1876 else
1877 log_failure "not found"
1878 fail
1879 fi
1880}
1881
1882
1883#
1884# Check for Java
1885#
1886check_java()
1887{
1888 test_header "Java support"
1889 log_success
1890}
1891
1892
1893#
1894# Setup wine
1895#
1896setup_wine()
1897{
1898 test_header "Wine support"
1899 if ! which_wrapper wine > /dev/null; then
1900 echo " wine binary not found"
1901 fail
1902 fi
1903 if ! which_wrapper wineprefixcreate > /dev/null; then
1904 echo " wineprefixcreate not found"
1905 fail
1906 fi
1907 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1908 echo "WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1909 echo "export WINEPREFIX" >> $ENV
1910 rm -rf $WINEPREFIX
1911 mkdir -p $WINEPREFIX
1912 touch $WINEPREFIX/.no_prelaunch_window_flag
1913 if ! wineprefixcreate -q > /dev/null 2>&1; then
1914 echo " wineprefixcreate failed"
1915 fail
1916 fi
1917 tmp=.tmp.wine.reg
1918 rm -f $tmp
1919 echo 'REGEDIT4' > $tmp
1920 echo '' >> $tmp
1921 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1922 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1923 echo '' >> $tmp
1924 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1925 echo '"itss"="native"' >> $tmp
1926 echo '' >> $tmp
1927 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1928 echo '"itss"="native"' >> $tmp
1929 echo '' >> $tmp
1930 if ! wine regedit $tmp > /dev/null 2>&1; then
1931 rm -f $tmp
1932 echo " failed to load registry changes (path)."
1933 fail
1934 fi
1935 rm -f $tmp
1936 log_success "found"
1937}
1938
1939#
1940# Check for gSOAP.
1941#
1942check_gsoap()
1943{
1944 test_header "GSOAP compiler"
1945 if [ -z "$GSOAP" ]; then
1946 GSOAP="/usr"
1947 fi
1948 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
1949 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
1950 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
1951 # TODO: Check for libgsoap++.a/so
1952
1953 if [ -z "$GSOAP_IMPORT" ]; then
1954 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
1955 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
1956 GSOAP_IMPORT="$GSOAP/include/gsoap"
1957 fi
1958 fi
1959 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
1960 cnf_append "VBOX_GSOAP_INSTALLED" "1"
1961 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
1962 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
1963 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
1964 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
1965 else
1966 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
1967 fi
1968 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoap++"
1969 log_success "found"
1970 else
1971 log_failure "stlvector.h not found -- disabling webservice"
1972 cnf_append "VBOX_WITH_WEBSERVICES" ""
1973 fi
1974 else
1975 log_failure "stdsoap2.h not found -- disabling webservice"
1976 cnf_append "VBOX_WITH_WEBSERVICES" ""
1977 fi
1978 else
1979 log_failure "wsdl2h not found -- disabling webservice"
1980 cnf_append "VBOX_WITH_WEBSERVICES" ""
1981 fi
1982 else
1983 log_failure "soapcpp2 not found -- disabling webservice"
1984 cnf_append "VBOX_WITH_WEBSERVICES" ""
1985 fi
1986}
1987
1988
1989#
1990# Determines the Darwin version.
1991# @todo This should really check the Xcode/SDK version.
1992#
1993check_darwinversion()
1994{
1995 test_header "Darwin version"
1996 darwin_ver=`uname -r`
1997 case "$darwin_ver" in
1998 10\.*)
1999 darwin_ver="10.6"
2000 sdk=/Developer/SDKs/MacOSX10.5.sdk
2001 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2002# test "$CC" = "gcc" && CC="gcc-4.0"
2003# test "$CXX" = "g++" && CXX="g++-4.0"
2004 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2005 ;;
2006 9\.*)
2007 darwin_ver="10.5"
2008 sdk=/Developer/SDKs/MacOSX10.5.sdk
2009 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2010# test "$CC" = "gcc" && CC="gcc-4.0"
2011# test "$CXX" = "g++" && CXX="g++-4.0"
2012 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2013 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2014 ;;
2015 8\.*)
2016 darwin_ver="10.4"
2017 sdk=/Developer/SDKs/MacOSX10.4u.sdk
2018 CXX_FLAGS="-mmacosx-version-min=10.4 -isysroot $sdk -Wl,-syslibroot,$sdk"
2019# test "$CC" = "gcc" && CC="gcc-4.0"
2020# test "$CXX" = "g++" && CXX="g++-4.0"
2021 cnf_append "VBOX_WITH_COCOA_QT" ""
2022 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2023 ;;
2024 *)
2025 echo " failed to determine Darwin version. (uname -r: $darwin_ver)"
2026 fail
2027 darwin_ver="unknown"
2028 ;;
2029 esac
2030 log_success "found version $darwin_ver (SDK: $sdk)"
2031}
2032
2033
2034#
2035# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
2036# is around to prevent confusion when the build fails in src/recompiler.
2037# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
2038#
2039check_i386elfgcc()
2040{
2041 test_header "i386-elf-gcc"
2042 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
2043 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
2044 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
2045 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
2046 if test -z "$i386_elf_gcc"; then
2047 echo " failed to find i386-elf-gcc"
2048 fail
2049 fi
2050 log_success "found $i386_elf_gcc"
2051}
2052
2053
2054#
2055# Show help
2056#
2057show_help()
2058{
2059cat << EOF
2060Usage: ./configure [OPTIONS]...
2061
2062Configuration:
2063 -h, --help display this help and exit
2064 --nofatal don't abort on errors
2065EOF
2066[ $WITH_XPCOM -eq 1 ] && echo " --disable-xpcom disable XPCOM and related stuff"
2067[ $WITH_PYTHON -eq 1 ] && echo " --disable-python disable python bindings"
2068[ $WITH_JAVA -eq 1 ] && echo " --disable-java disable java bindings"
2069[ $WITH_VMMRAW -eq 1 ] && echo " --disable-vmmraw disable VMM raw mode (VT-x/AMD-V mandatory!)"
2070[ $WITH_SDL_TTF -eq 1 ] && echo " --disable-sdl-ttf disable SDL_ttf detection"
2071[ $WITH_ALSA -eq 1 ] && echo " --disable-alsa disable the ALSA sound backend"
2072[ $WITH_PULSE -eq 1 ] && echo " --disable-pulse disable the PulseAudio backend"
2073[ $WITH_DBUS -eq 1 ] && echo " --disable-dbus don't use DBus and hal for hardware detection"
2074[ $WITH_KMODS -eq 1 ] && echo " --disable-kmods don't build Linux kernel modules (host and guest)"
2075[ $WITH_OPENGL -eq 1 ] && echo " --disable-opengl disable OpenGL support (2D & 3D)"
2076[ $WITH_GSOAP -eq 0 ] && echo " --enable-webservice enable the webservice stuff"
2077[ "$OS" = "linux" -o "$OS" = "freebsd" ] && echo " --enable-vde enable VDE networking"
2078cat << EOF
2079 --disable-hardening don't be strict about /dev/vboxdrv access
2080 --build-libxml2 build libxml2 from sources
2081 --build-libxslt build libxslt from sources
2082EOF
2083[ $OSE -eq 0 ] && cat << EOF
2084 --build-libssl build openssl from sources
2085 --build-libcurl build libcurl from sources
2086EOF
2087[ "$OS" != "darwin" ] && echo " --setup-wine setup a Wine directory and register the hhc hack"
2088cat << EOF
2089
2090Paths:
2091 --with-gcc=PATH location of the gcc compiler [$CC]
2092 --with-g++=PATH location of the g++ compiler [$CXX]
2093 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
2094 --with-iasl=PATH location of the iasl compiler [$IASL]
2095 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
2096EOF
2097[ "$OS" = "linux" ] && echo " --with-linux=DIR Linux kernel source directory [$LINUX]"
2098[ $WITH_QT4 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt4 headers/libraries [pkgconfig]"
2099[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries"
2100[ $WITH_GSOAP -eq 1 ] && echo " (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)"
2101[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)"
2102cat << EOF
2103 --with-openssl-dir=DIR directory for OpenSSL headers/libraries
2104 --out-path=PATH the folder to which configuration and build output
2105 should go
2106
2107Build type:
2108 -d, --build-debug build with debugging symbols and assertions
2109 --build-profile build with profiling support
2110 --build-headless build headless (without any GUI frontend)
2111EOF
2112 exit 0
2113}
2114
2115
2116#
2117# The body.
2118#
2119
2120# test if we are OSE
2121if [ $OSE -eq 1 -a -r "`cd \`dirname $0\`; pwd`/src/VBox/Devices/USB/USBProxyDevice.cpp" ]; then
2122 OSE=0
2123 # Set this as a reminder to print a log message once we know the path of the
2124 # log file
2125 NOT_OSE=1
2126fi
2127
2128# Change OS specific defaults; must be before all other stuff
2129if [ "$OS" = "darwin" ]; then
2130 WITH_SDL=0
2131 WITH_SDL_TTF=0
2132 WITH_X11=0
2133 WITH_ALSA=0
2134 WITH_PULSE=0
2135 WITH_DBUS=0
2136 WITH_KMODS=0
2137 BUILD_LIBXSLT=1
2138 BUILD_LIBXML2=1
2139 [ $OSE -eq 1 ] || BUILD_LIBCURL=1
2140 [ $OSE -eq 1 ] || BUILD_LIBSSL=1
2141fi
2142
2143
2144# scan command line options
2145for option in $*; do
2146 case "$option" in
2147 --help|-help|-h)
2148 show_help
2149 ;;
2150 --nofatal)
2151 nofatal=1
2152 ;;
2153 --env-only)
2154 ENV_ONLY=1
2155 ;;
2156 --with-gcc=*)
2157 CC=`echo $option | cut -d'=' -f2`
2158 ;;
2159 --with-g++=*)
2160 CXX=`echo $option | cut -d'=' -f2`
2161 ;;
2162 --with-kbuild=*)
2163 KBUILDDIR=`echo $option | cut -d'=' -f2`
2164 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
2165 echo "Error: KBUILDDIR contains invalid characters!"
2166 exit 1
2167 fi
2168 ;;
2169 --with-qt-dir=*|--with-qt4-dir=*)
2170 QT4DIR=`echo $option | cut -d'=' -f2`
2171 QT4DIR_PKGCONFIG=0
2172 ;;
2173 --with-openssl-dir=*)
2174 OPENSSLDIR=`echo $option | cut -d'=' -f2`
2175 INCCRYPTO="-I${OPENSSLDIR}/include"
2176 LIBCRYPTO="${OPENSSLDIR}/lib/libcrypto.a"
2177 ;;
2178 --with-gsoap-dir=*)
2179 GSOAP=`echo $option | cut -d'=' -f2`
2180 ;;
2181 --with-gsoap-import=*)
2182 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
2183 ;;
2184 --with-iasl=*)
2185 IASL=`echo $option | cut -d'=' -f2`
2186 ;;
2187 --with-linux=*)
2188 LINUX=`echo $option | cut -d'=' -f2`
2189 ;;
2190 --with-mkisofs=*)
2191 MKISOFS=`echo $option | cut -d'=' -f2`
2192 ;;
2193 --target-arch=*)
2194 TARGET_MACHINE=`echo $option | cut -d'=' -f2`
2195 ;;
2196 --disable-xpcom)
2197 [ $WITH_XPCOM -eq 1 ] && WITH_XPCOM=0
2198 ;;
2199 --disable-python)
2200 [ $WITH_PYTHON -eq 1 ] && WITH_PYTHON=0
2201 ;;
2202 --disable-java)
2203 [ $WITH_JAVA -eq 1 ] && WITH_JAVA=0
2204 ;;
2205 --disable-vmmraw)
2206 [ $WITH_VMMRAW -eq 1 ] && WITH_VMMRAW=0
2207 ;;
2208 --disable-sdl-ttf)
2209 [ $WITH_SDL_TTF -eq 1 ] && WITH_SDL_TTF=0
2210 ;;
2211 --disable-qt)
2212 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2213 ;;
2214 --disable-qt4)
2215 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2216 ;;
2217 --passive-mesa)
2218 PASSIVE_MESA=1
2219 ;;
2220 --disable-alsa)
2221 [ $WITH_ALSA -eq 1 ] && WITH_ALSA=0
2222 ;;
2223 --disable-pulse)
2224 [ $WITH_PULSE -eq 1 ] && WITH_PULSE=0
2225 ;;
2226 --enable-pulse)
2227 WITH_PULSE=2
2228 ;;
2229 --disable-dbus)
2230 [ $WITH_DBUS -eq 1 ] && WITH_DBUS=0
2231 ;;
2232 --disable-kmods)
2233 [ $WITH_KMODS -eq 1 ] && WITH_KMODS=0
2234 ;;
2235 --disable-opengl)
2236 [ $WITH_OPENGL -eq 1 ] && WITH_OPENGL=0
2237 ;;
2238 --enable-webservice)
2239 [ $WITH_GSOAP -eq 0 ] && WITH_GSOAP=1
2240 ;;
2241 --disable-hardening)
2242 WITH_HARDENING=0
2243 ;;
2244 --enable-hardening)
2245 WITH_HARDENING=2
2246 ;;
2247 --enable-vde)
2248 WITH_VDE=1
2249 ;;
2250 --build-debug|-d)
2251 BUILD_TYPE=debug
2252 ;;
2253 --build-profile)
2254 BUILD_TYPE=profile
2255 ;;
2256 --build-libxml2)
2257 BUILD_LIBXML2=1
2258 ;;
2259 --build-libxslt)
2260 BUILD_LIBXSLT=1
2261 ;;
2262 --build-libssl)
2263 BUILD_LIBSSL=1
2264 ;;
2265 --build-libcurl)
2266 BUILD_LIBCURL=1
2267 ;;
2268 --build-headless)
2269 HEADLESS=1
2270 WITH_SDL=0
2271 WITH_SDL_TTF=0
2272 WITH_X11=0
2273 WITH_OPENGL=0
2274 WITH_QT4=0
2275 ;;
2276 --ose)
2277 OSE=2
2278 ;;
2279 --odir=*)
2280 ODIR="`echo $option | cut -d'=' -f2`/"
2281 ODIR_OVERRIDE=1
2282 ;;
2283 --out-path=*)
2284 out_path="`echo $option | cut -d'=' -f2`/"
2285 if [ -d $out_path ]; then
2286 saved_path="`pwd`"
2287 cd $out_path
2288 OUT_PATH="`pwd`"
2289 cd $saved_path
2290 OUT_PATH_OVERRIDE=1
2291 if [ $ODIR_OVERRIDE -eq 0 ]; then
2292 # This variable has not *yet* been overridden. That can still happen.
2293 ODIR=$OUT_PATH/
2294 fi
2295 else
2296 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2297 exit 1
2298 fi
2299 ;;
2300 --setup-wine)
2301 [ "$OS" != "darwin" ] && SETUP_WINE=1
2302 ;;
2303 *)
2304 echo
2305 echo "Unrecognized option \"$option\""
2306 echo
2307 show_help
2308 ;;
2309 esac
2310done
2311
2312LOG="$ODIR$LOG"
2313ENV="$ODIR$ENV"
2314CNF="$ODIR$CNF"
2315
2316# initialize output files
2317cat > $LOG << EOF
2318# Log file generated by
2319#
2320# '$0 $*'
2321#
2322
2323EOF
2324cat > $CNF << EOF
2325# -*- Makefile -*-
2326#
2327# automatically generated by
2328#
2329# '$0 $*'
2330#
2331# It will be completely overwritten if configure is executed again.
2332#
2333
2334EOF
2335cat > $ENV << EOF
2336#!/bin/bash
2337#
2338# automatically generated by
2339#
2340# '$0 $*'
2341#
2342# It will be completely overwritten if configure is executed again.
2343# Make sure you source this file once before you start to build VBox.
2344#
2345
2346EOF
2347
2348# Print log warning about OSE if necessary
2349if [ -n "$NOT_OSE" ]; then
2350 echo "Found USB devices, assuming VBOX_OSE = FALSE" >> $LOG
2351 echo >> $LOG
2352fi
2353
2354
2355if [ "$BUILD_TYPE" = "debug" ]; then
2356 echo "Creating DEBUG build!" >> $LOG
2357elif [ "$BUILD_TYPE" = "profile" ]; then
2358 echo "Creating PROFILE build!" >> $LOG
2359fi
2360
2361# first determine our environment
2362check_environment
2363check_kbuild
2364
2365[ -n "$ENV_ONLY" ] && exit 0
2366
2367# append the tools directory to the default search path
2368echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2369export PATH
2370
2371# if we will be writing to a different out directory then set this up now
2372if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2373 echo "AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2374 echo "export AUTOCFG" >> $ENV
2375 echo "LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2376 echo "export LOCALCFG" >> $ENV
2377 echo "PATH_OUT_BASE=$OUT_PATH" >> $ENV
2378 echo "export PATH_OUT_BASE" >> $ENV
2379fi
2380
2381# some things are not available in for OSE
2382if [ $OSE -ge 1 ]; then
2383 cnf_append "VBOX_OSE" "1"
2384 cnf_append "VBOX_WITH_TESTSUITE" ""
2385 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2386
2387 if [ "$OS" = "linux" ]; then
2388 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2389 else
2390 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2391 fi
2392 echo >> $CNF
2393fi
2394
2395# headless
2396if [ -n "$HEADLESS" ]; then
2397 cnf_append "VBOX_HEADLESS" "1"
2398fi
2399
2400# emit disable directives corresponding to any --disable-xxx options.
2401if [ $WITH_OPENGL -eq 0 ]; then
2402 cnf_append "VBOX_WITH_CROGL" ""
2403 cnf_append "VBOX_WITH_VIDEOHWACCEL" ""
2404 cnf_append "VBOX_GUI_USE_QGL" ""
2405fi
2406[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2407[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2408[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2409[ $WITH_PYTHON -eq 0 ] && cnf_append "VBOX_WITH_PYTHON" ""
2410[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JXPCOM" ""
2411[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2412[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2413[ $WITH_VMMRAW -eq 0 ] && cnf_append "VBOX_WITH_RAW_MODE" ""
2414
2415# Darwin-specific
2416if [ "$OS" = "darwin" ]; then
2417 check_darwinversion
2418fi
2419# the tools
2420check_gcc
2421[ "$OS" != "darwin" ] && check_as86
2422[ "$OS" != "darwin" ] && check_bcc
2423[ "$OS" != "darwin" ] && check_iasl
2424# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2425# [ "$OS" != "darwin" ] && check_yasm
2426[ "$OS" != "darwin" ] && check_xsltproc
2427[ $OSE -eq 0 -a "$OS" != "darwin" ] && check_mkisofs
2428
2429# the libraries
2430[ "$OS" != "darwin" ] && check_pthread
2431check_libxml2
2432[ $WITH_XPCOM -eq 1 ] && check_libxslt
2433[ $WITH_LIBIDL -eq 1 ] && check_libidl
2434check_ssl
2435check_curl
2436[ "$OS" != "darwin" ] && check_z
2437[ "$OS" != "darwin" -a "$OS" != "freebsd" ] && check_png
2438[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2439[ $WITH_SDL -eq 1 ] && check_sdl
2440[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2441[ $WITH_X11 -eq 1 ] && check_x
2442# TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2443# TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2444[ $WITH_X11 -eq 1 ] && check_xcursor
2445[ $WITH_X11 -eq 1 ] && check_xinerama
2446[ $WITH_X11 -eq 1 ] && check_xrandr
2447[ $WITH_OPENGL -eq 1 ] && check_opengl
2448[ $WITH_QT4 -eq 1 ] && check_qt4
2449[ $WITH_PYTHON -eq 1 ] && check_python
2450[ $WITH_JAVA -eq 1 ] && check_java
2451
2452# PulseAudio
2453if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2454 if [ $WITH_PULSE -eq 1 ]; then
2455 check_pulse
2456 elif [ $WITH_PULSE -eq 0 ]; then
2457 cnf_append "VBOX_WITH_PULSE" ""
2458 fi
2459fi
2460
2461# Linux-specific
2462if [ "$OS" = "linux" ]; then
2463 # don't check for the static libstdc++ in the PUEL version as we build the
2464 # additions at a dedicated box
2465 [ $OSE -ge 1 ] && check_staticlibstdcxx
2466 if [ $WITH_KMODS -eq 1 ]; then
2467 check_linux
2468 else
2469 cnf_append "VBOX_LINUX_SRC" ""
2470 cnf_append "VBOX_WITH_VBOXDRV" ""
2471 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2472 fi
2473 if [ $WITH_ALSA -eq 1 ]; then
2474 check_alsa
2475 else
2476 cnf_append "VBOX_WITH_ALSA" ""
2477 fi
2478 if [ $WITH_DBUS -eq 0 ]; then
2479 cnf_append "VBOX_WITH_DBUS" ""
2480 fi
2481 check_libcap
2482 check_compiler_h
2483 [ "$BUILD_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 1 ] && check_32bit
2484fi
2485
2486[ -n "$SETUP_WINE" ] && setup_wine
2487
2488if [ $OSE -ge 1 ]; then
2489 if [ $WITH_GSOAP -eq 1 ]; then
2490 check_gsoap
2491 else
2492 cnf_append "VBOX_WITH_WEBSERVICES" ""
2493 fi
2494fi
2495
2496# VDE
2497if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2498 if [ $WITH_VDE -eq 1 ]; then
2499 cnf_append "VBOX_WITH_VDE" "1"
2500 fi
2501fi
2502
2503# success!
2504echo
2505echo "Successfully generated '$CNF' and '$ENV'."
2506echo "Source '$ENV' once before you start to build VBox:"
2507echo ""
2508echo " source $ENV"
2509echo " kmk"
2510echo ""
2511if [ "$OS" = "linux" ]; then
2512 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2513 vbox_out_path=$OUT_PATH
2514 else
2515 vbox_out_path=./out
2516 fi
2517 echo "To compile the kernel modules, do:"
2518 echo ""
2519 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2520 echo " make"
2521 echo ""
2522fi
2523if [ $WITH_HARDENING -gt 0 ]; then
2524 echo ""
2525 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2526 echo " Hardening is enabled which means that the VBox binaries will not run from"
2527 echo " the binary directory. The binaries have to be installed suid root and some"
2528 echo " more prerequisites have to be fulfilled which is normally done by installing"
2529 echo " the final package. For development, the hardening feature can be disabled"
2530 echo " by specifying the --disable-hardening parameter. Please never disable that"
2531 echo " feature for the final distribution!"
2532 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2533 echo ""
2534else
2535 echo ""
2536 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2537 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2538 echo " disabled hardening!"
2539 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2540 echo ""
2541fi
2542echo "Enjoy!"
2543cleanup
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use